// Number 15;
// Druchenko Andrew
// Client part modules list
// _15Prime,_15DataStruct,_15ClientUnit;

unit _15ClientUnit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, ScktComp,_15DataStruct,_15Prime;

type
  TForm1 = class(TForm)
    Client: TClientSocket;
    SpinEdit1: TSpinEdit;
    Label1: TLabel;
    Button1: TButton;
    Label2: TLabel;
    Edit3: TEdit;
    Memo1: TMemo;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure ClientConnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure ClientDisconnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure ClientRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure Button2Click(Sender: TObject);
    procedure ClientError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
// Connecting to Server
begin
Client.Port:=Spinedit1.value;
Client.Host:=Edit3.text;
Client.Open;
end;

procedure TForm1.ClientConnect(Sender: TObject; Socket: TCustomWinSocket);
begin
caption:='Connected';
end;

procedure TForm1.ClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
caption:='Disconnected';
end;

procedure TForm1.ClientRead(Sender: TObject; Socket: TCustomWinSocket);

var data:TDataPacket;
    s:string;
    i:cardinal;
begin
data.PrimeList:=TStringList.create;
s:=socket.ReceiveText;
LoadFromStr(s,data);

if data.ID<>-1 then begin  // a usual connection
//Starting a calculation of prime numbers

    for i:=data.Range1 to data.Range2 do
      if CheckPrime(i) then Data.PrimeList.Add(IntToStr(i));

   WriteToStr(data,s);
   Socket.SendText(s);

   end else begin// this is where client gets a list of prime numbers

     memo1.lines.assign(Data.PrimeList);


    end;

data.PrimeList.free;
end;

procedure TForm1.Button2Click(Sender: TObject);
var data:TDataPacket;
    s:string;
begin
data.PrimeList:=TstringList.Create;
data.ID:=-1;
WriteToStr(data,s);
Client.Socket.SendText(s);

end;

procedure TForm1.ClientError(Sender: TObject; Socket: TCustomWinSocket;
  ErrorEvent: TErrorEvent; var ErrorCode: Integer);
begin
caption:='There were some errors:'+Inttostr(ErrorCode);
socket.Close;
end;

end.
