unit _15DataStruct;

interface
uses classes,sysutils;

type TDataPacket=record //

     ID:integer;           //
     Range1:Cardinal;   //  Parameters for client that server will send him
     Range2:Cardinal;   //


     Finished:boolean; // This means that the work of client is finished
                       //  and it wants  another job

     NumbersFound:Cardinal; // The total number of found prime numbers
     PrimeList:TStringList; // A list of prime numbers of current cleint
                            // This list he'll send to server

     end;

//* NOTE:
//  The server will use the same structure to send the list
//  of prime numbers to client.
//  To identify this it'll use ID=-1. So if the client will
//  send server a DataPacket with the ID = -1 the server will
//  return client fields Numbersfound and PrimeList which contains
//  all found prime numbers to the current moment

procedure LoadFromStr(s:string;var Data:TDataPacket);
 // A procedure for loading a data from  string to Data record;
 // All above mensioned values in record are written to string
 // using separator '!'. They are used also to separate
 // strings in PrimeList.
 // Input string must end with '!'


procedure WriteToStr(Data:TDataPacket;var s:string);
 // A procedure that do the inverse operation to previous

implementation

procedure WriteToStr(Data:TDataPacket;var s:string);
var i:integer;
begin

s:=IntTostr(data.ID)+'!'+
   IntToStr(data.Range1)+'!'+
   IntToStr(data.Range2)+'!'+
   IntToStr(byte(data.Finished))+'!'+
   IntTostr(data.NumbersFound)+'!';

for i:=0 to Data.PrimeList.count-1 do
         s:=s+Data.PrimeList.strings[i]+'!';

end;


// It's important to create a TStringList object before
// passing data to this procedure
procedure LoadFromStr(s:string;var Data:TDataPacket);

var i:integer;
    tmp:string;
 begin

 i:=1;

//Writing data.ID
 tmp:='';
 while (s[i]<>'!') do begin
   tmp:=tmp+s[i];inc(i);
    if i>length(s) then exit;
   end;
 i:=i+1;
 Data.ID:=StrToInt(tmp);

// Writing data.Range1
 tmp:='';
 while (s[i]<>'!') do begin
   tmp:=tmp+s[i];inc(i);
    if i>length(s) then exit;
   end;
 i:=i+1;
 Data.Range1:=StrToInt(tmp);

// Writing data.Range2
 tmp:='';
 while (s[i]<>'!') do begin
   tmp:=tmp+s[i];inc(i);
    if i>length(s) then exit;
   end;
 i:=i+1;
 Data.Range2:=StrToInt(tmp);

// Writing data.Finished
 tmp:='';
 while (s[i]<>'!') do begin
   tmp:=tmp+s[i];inc(i);
    if i>length(s) then exit;
   end;
 i:=i+1;
 Data.Finished:=Boolean(StrToInt(tmp));

// Writing data.NumbersFound
 tmp:='';
 while (s[i]<>'!') do begin
   tmp:=tmp+s[i];inc(i);
    if i>length(s) then exit;
   end;
 i:=i+1;
 Data.NumbersFound:=StrToInt(tmp);


// Writing data.PrimeList
// Data.PrimeList:=TstringList.Create;

    while i<=length(s) do begin
         tmp:='';
           while (s[i]<>'!') do begin
              tmp:=tmp+s[i];inc(i);
              if i>length(s) then exit;
           end;
         i:=i+1;
         Data.PrimeList.add(tmp);
     end;

end;






end.
